using Test
function verifica()
  @test quadradoLatino([1 2; 1 2]) == false
  @test quadradoLatino([1  2  3; 2  3  1; 3  1  2])
  @test quadradoLatino([1 2 3 4; 2 1 4 3; 3 4 2 1; 4 3 1 2])
  println("Final dos testes")
end

function permutacao(v)
   tam = length(v)
   aux = zeros(Int, tam)
   for i in 1:tam
     if v[i] in 1:tam
        aux[v[i]] += 1
     else
        return false
     end
   end
   for i in 1:tam
     if aux[i] != 1
        return false
     end
   end
   return true
end


function quadradoLatino(m)
  dim = size(m)
  if length(dim) != 2 || dim[1] != dim[2]
    return false
  else
    tamanho = dim[1]
    v = zeros(Int, tamanho)

    for i in 1:tamanho
       # verifica a linha i
       for j in 1:tamanho
          v[j] = m[i, j]
       end
       if !permutacao(v)
         return false
       end
       # verifica a coluna i
       for j in 1:tamanho
          v[j] = m[j, i]
       end
       if !permutacao(v)
         return false
       end
     end
  end
  return true
end

verifica()
