
function verifica()
   m = [1 0 0 1 0 0; 1 1 0 1 0 1; 1 0 0 1 1 1; 1 0 1 1 1 1; 1 0 1 1 1 1;
    1 0 1 1 1 1 ]
   imprime(m)
   println(toboga(m))
   imprime(m)
end

function imprime(m)
  dim = size(m)
  for i in 1:dim[1]
    for j in 1:dim[2]
       if m[i, j] == 1
         print("X")
       elseif m[i, j] == 0
         print(".")
       else
         print("~")
       end
   end
   println()
  end
end

function toboga(m)
  dim = size(m)
  if length(dim) != 2 || dim[1] != dim[2]
    return false
  else
    for i in 1:dim[1]
       if m[1, i] == 0
          m[1, i] = 2 # marca de água
          tobogaRec(m, 1, i)
       end
    end

    for i in 1:dim[1]
      if m[dim[1], i] == 2 # chegou água
        return true
      end
    end
  end
  return false
end

function tobogaRec(m, i, j)
   dim = size(m)
   # para baixo
   if i + 1 <= dim[1] && m[i + 1, j] == 0
      m[i + 1, j] = 2
      tobogaRec(m, i + 1, j)
   end
   # para esquerda
   if j - 1 >= 1 && m[i, j - 1] == 0
      m[i, j - 1] = 2
      tobogaRec(m, i, j - 1)
   end
   # para direita
   if j + 1 <= dim[1] && m[i, j + 1] == 0
      m[i, j + 1] = 2
      tobogaRec(m, i, j + 1)
   end
   # para cima
   if i - 1 >= 1 && m[i - 1, j] == 0
      m[i - 1, j] = 2
      tobogaRec(m, i - 1, j)
   end
end
     
verifica()
